Attribute VB_Name = "modPruefZiffer"
' *************************************************************************
'  Funktion zur Ermittlung einer Prfziffer bei NVE/EAN - Barcodes
'  (Ausfhrlich nur mit NVE 128 (EAN128) getestet !!!!)
'
'  Die Berechnung wird nach Modula 10 durchgefhrt, dies entspricht
'  dem internationalen Standard zur Ermittlung von Prfziffern
'  von NVE und EAN - Barcodes.
' *************************************************************************
'
'  Beispiel fr eine simple Anwendung:
'
'  Private Sub Command2_Click()
'
'      Dim Ziffer As String
'
'      Ziffer = PruefZiffer(Me!Text1)
'      Me!Label1.Caption = Ziffer
'
'  End Sub
'
' *************************************************************************
' (c) copyright by UKS, Bielefeld (2001)
'
'   Internet: http://www.u-kersten.de
'   Email: vb@u-kersten.de
'
'   Fr Fragen und konstruktive Vorschlge zur Verbesserung bin
'   ich immer zu haben !!!
' *************************************************************************


Public Function PruefZiffer(Nummer As String) As String
On Error GoTo ErrZiffer
    
   Dim a, b, c, d, e, f, pz As Integer
   
   a = -1
   b = 0
   c = 0
   d = 0
   
   For i = 0 To 9
    a = a + 2
    b = b + 2
    c = CInt(Mid(Right(CStr(Nummer), a), 1, 1))
    d = CInt(Mid(Right(CStr(Nummer), b), 1, 1))
    e = e + (3 * c)
    f = f + d
   Next
   
   pz = 10 - Right(e + f, 1)
   If pz = 10 Then pz = 0
   
   PruefZiffer = Nummer & pz
   
ExitZiffer:
    Exit Function
    
ErrZiffer:
    MsgBox Err.Description
    Resume ExitZiffer
   
End Function
